算法练习14:leetcode习题871. Minimum Number of Refueling Stops

题目

A car travels from a starting position to a destination which is target miles east of the starting position.

Along the way, there are gas stations. Each station[i] represents a gas station that is station[i][0] miles east of the starting position, and has station[i][1] liters of gas.

The car starts with an infinite tank of gas, which initially has startFuel liters of fuel in it. It uses 1 liter of gas per 1 mile that it drives.

When the car reaches a gas station, it may stop and refuel, transferring all the gas from the station into the car.

What is the least number of refueling stops the car must make in order to reach its destination? If it cannot reach the destination, return -1.

Note that if the car reaches a gas station with 0 fuel left, the car can still refuel there. If the car reaches the destination with 0 fuel left, it is still considered to have arrived.

  1. 1 <= target, startFuel, stations[i][1] <= 10^9
  2. 0 <= stations.length <= 500
  3. 0 < stations[0][0] < stations[1][0] < … < stations[stations.length-1][0] < target

Example 1:
Input: target = 1, startFuel = 1, stations = []
Output: 0
Explanation: We can reach the target without refueling.

Example 2:
Input: target = 100, startFuel = 1, stations = [[10,100]]
Output: -1
Explanation: We can’t reach the target (or even the first gas station).

Example 3:
Input: target = 100, startFuel = 10, stations = [[10,60],[20,30],[30,30],[60,40]]
Output: 2
Explanation:
We start with 10 liters of fuel.
We drive to position 10, expending 10 liters of fuel. We refuel from 0 liters to 60 liters of gas.
Then, we drive from position 10 to position 60 (expending 50 liters of fuel),
and refuel from 10 liters to 50 liters of gas. We then drive to and reach the target.
We made 2 refueling stops along the way, so we return 2.

算法思路

本周继续学习动态规划的思想,本题也是使用动态规划的案例,不过这个题目寻找恰当的子问题会困难一些。

我们考虑以maxlen(n)作为为经过n个加油站能到达的最远距离,接下来我们考虑怎么沿着加油站列表更新maxlen(n)的值。

  1. n=0时,显然maxlen(0) = startfuel
  2. 逐步考虑前i个加油站的maxlen(n)数组,当添加一个新的加油站i时,原maxlen数组中maxlen[j] >= stations[i][0]的部分,即能到达新加油站的值能更新后一个值,maxlen[j+1] = (maxlen[j+1],maxlen[j] + stations[i][1])

C++代码

class Solution {
public:
    int minRefuelStops(int target, int startFuel, vector<vector<int>>& stations) {
        unsigned int maxlen[stations.size()+1] = {0};
        maxlen[0] = startFuel;

        for (int i = 0; i < stations.size(); ++i)
        {
            for (int j = i; j >= 0; --j)
            {
                if (maxlen[j] >= stations[i][0] && maxlen[j+1] < maxlen[j] + stations[i][1])
                {
                    maxlen[j+1] = maxlen[j] + stations[i][1];
                }
            }
        }

        for (int i = 0; i <= stations.size(); ++i)
        {
            if (maxlen[i] >= target)
            {
                return i;
            }
        }

        return -1;
    }
};

猜你喜欢

转载自blog.csdn.net/m0_37779608/article/details/84781347